/*****************************************************************************/
/*                        WiNRADiO G39DDC EXCELSIOR                          */
/*                                SDK DEMO                                   */
/*                        (C) Copyright RADIXON 2014                         */
/*****************************************************************************/

#include "u_mainwindow.h"
#include "u_receiverselector.h"
#include "u_defs.h"
#include "u_global.h"
#include <dlfcn.h>

class TApp: public wxApp
{
public:
    bool OnInit(void);
};

G39DDCAPI_CREATE_INSTANCE CreateInstance;

bool TApp::OnInit(void)
{
 TMainWindow *MainWindow;
 TReceiver *Receiver;
 void *API;

    API=dlopen("libg39ddcapi.so",RTLD_LAZY);

    if(API==NULL)
    {
        wxMessageBox(wxT("Failed to load libg39ddcapi.so!"),APP_TITLE,wxICON_ERROR);
        return false;
    }

    CreateInstance=(G39DDCAPI_CREATE_INSTANCE)dlsym(API,"CreateInstance");

    if(CreateInstance==NULL)
    {
        wxMessageBox(wxT("Failed to load valid libg39ddcapi.so!"),APP_TITLE,wxICON_ERROR);
        dlclose(API);
        return false;
    }

    Global.Initialize();

    Receiver=TReceiverSelector::SelectReceiver();

    if(Receiver==NULL)
    {
        return false;
    }

    MainWindow=new TMainWindow(Receiver);

    Global.m_MainWindow=MainWindow;

    MainWindow->Show(true);

    return true;
}

IMPLEMENT_APP(TApp)
